Page MenuHomePhabricator

GSoC 2019 Proposal: Create a subpage for statistics and charts related to a hashtag search
Closed, DeclinedPublic

Description

Profile Information

Name: Parth Shandilya
IRC nickname on Freenode: parths007
GitHub Profile: https://github.com/ParthS007
Location: India (UTC +5:30)
Typical working hours: Between 8 PM and 3 AM (UTC +5:30)

Synopsis

  • The Hashtags tool allows users to search for uses of hashtags (e.g. #1Lib1Ref) in Wikimedia edit summaries.
  • Its current functionality is quite basic - a few simple search options and listed results, with the option to download the results as a CSV or read them as JSON.
  • A number of Wikimedia campaigns use this tool to track edits and would like to be able to delve into the data a little more.
  • We would, therefore, like to add a page user can click through to for a given search showing more detailed statistics, graphs, and charts.
  • This project ‘Create a Subpage for statistics and charts related to a hashtag search’ aims at creating a page which would display more detailed statistics, charts and graphs for a given search. Users can also optionally download the detailed data as CSV.
  • Possible Mentor: @Samwalton9

Timeline

Community Bonding

May 6 - May 18

  • Solving existing bugs in the project.
  • Get Involved with Hashtags community and interact with the other students.

May 19 - May 27

  • Discussions with Mentors and know more about mentors such as their timezone, preferred medium of communication, etc.
  • Get acquainted with various tools used in Hashtags Project.
First Coding Period

May 27 - June 8

  • I’ll start working on different APIs to show user and project statistics.
  • Explore JavaScript libraries and finalize which one to use
  • Design a template for the statistics page. It will include the tags where to render the charts on the page.

June 9 - June 24

  • Designing of template for Statistics page.
  • Implement an API for time vs the number of the edits bar graph.
First evaluation

June 24 - June 28

  • Time period for any unexpected delay.
Second Coding Period

June 28 - July 10

  • Implement an API for time vs the number of the edits bar graph.
  • Work on requested changes in Pull requests.

July 10 - July 22

  • Implementing the statistics page.
  • Adding Tests for added APIs
Second evaluation

July 22 - July 26

  • Time period for any unexpected delay.
Final Coding Period

July 27 - Aug 8

  • Ask feedback from the users and implement suggestions.
  • Write APIs for downloading statistics as CSV.
  • Integrate the download CSV APIs with UI

August 9 - August 19

  • Adding Tests for remaining APIs.
  • Write the documentation for all the work done up till now.
Final evaluation

Aug 20 - Aug 26

  • Write Project Summary and prepare a GIST for submission.

Deliverables

After the completion of the Internship, the tool will have the following features:

  • There will be an option beside the download link which will lead us to the statistics page.
  • The statistics page will have tables with their respective charts and graphs. The first table will display the Wikimedia projects which are present in the search results and the number of edits belonging to that project sorted by decreasing order of their number of edits.
  • The second table will display the top 10 users who have used those hashtags in the edit summary sorted by decreasing order of their number of edits. (we will also display the wikimedia projects they have contributed to)
  • There will be an option to download each of these statistics as CSV.
  • Also, there will be test coverage for all the new APIs.

Participation

  • I will be submitting PRs on the already existing codebase https://github.com/Samwalton9/hashtags
  • I have been and will be in constant touch with my mentor, Sam Walton.
  • For sharing status and discussing ideas, I will be using phabricator. I will be active on IRC, Zulip chat and Gmail during my working hours.
  • I will be writing a blog for sharing my experience and progress on this project. I plan to do it for every evaluation.

About Me

Education

  • I am a 3rd-year Undergraduate Computer & Communication Engineering Student at The LNM Institute of Information Technology, India

How did you hear about this program?

  • One of my senior participated in Outreachy and told me about the project. I was also Google Summer of Code 2018 Student Intern where I worked in the open source organization FOSSASIA.

Will you have any other time commitments, such as school work, another job, planned vacation, etc, during the duration of the program?

  • I will be completely free till July. After that my college will start but I will still be able to give 7-8 hours on weekends and 3-4 hours on weekdays as there wouldn’t be any exams during that period.

We advise all candidates eligible for Google Summer of Code and Outreachy to apply for both programs. Are you planning to apply to both programs and, if so, with what organization(s)?

  • I am only applying for Google Summer of Code with Wikimedia organization.

What does making this project happen mean to you?

  • I have been contributing to Wikipedia for some time now. I am inspired and thrilled by the vision of Wikipedia of making contents available in every natural language. I think contributing to Wikimedia will impact the world in a very positive manner. At the same time for me, it will push the horizon even farther by letting me collaborate with the excellent Wikimedia community members. Most importantly I will be making something that will make the world's largest free encyclopedia, among other Wikimedia sites, richer in content and organization.

Past Experience

  • I was a Google Summer of Code 2018 Student Intern where I worked in the open source organization FOSSASIA, on Badgeyay Project, which is an open source badge generation and management system. My work was Python, JS-based (I worked with Python's Flask web framework with SQLAlchemy ORM on top of PostgreSQL database with Ember JS as frontend framework). My blog post related to my work in GSoC 2018 can be found here.
  • I have worked on some popular open-source projects with varied tech stack in different open-source organizations. Please find the link below of some major open source projects I contributed to:
  • I have also worked on other technologies like Continuous Integration and Deployment and also on developing environment using Travis CI and Code-tests like unit tests for REST APIs, Code coverage using Codecov. I have worked on cloud-based services like Docker and Heroku.
  • I have experience in programming with multiple languages such as Python, C, JavaScript, Also, most of my work is open source. I also write blog posts related to various technologies at medium, as well as answers and moderates questions on StackOverflow.

Contributions to Wikimedia

I have been exploring Wikimedia projects since Mid Feb. So far I have explored and fixed some bugs of Hashtags.

Event Timeline

ParthS007 created this task.Apr 2 2019, 2:54 PM
Samwalton9 added a comment.EditedApr 3 2019, 12:59 PM

Thanks for this proposal!

Just a quick question - in parts of your proposal you appear to have used identical wording to that found in the other current proposal for this task (T218986), e.g. "After that my college will start but I will still be able to give 7-8 hours on weekends and 3-4 hours on weekdays as there wouldn’t be any exams during that period." and "I am only applying for Google Summer of Code with Wikimedia organization." Could you confirm that this information applies to you too?

The 'Deliverables' section also appears to be copied from the other proposal. Could you rewrite this to reflect your proposal?

Yes @Samwalton9 , both apply to me as well.

okay, I will change the Deliverables section. :)

Thanks for the review.

ParthS007 updated the task description. (Show Details)Apr 8 2019, 2:33 PM

If you would like us to consider your proposal for review, please move it to the submitted column on Google-Summer-of-Code (2019) board.

(look for next steps in the email you'll receive shortly with an option to request for a debrief on why your proposal was not accepted)

srishakatux closed this task as Declined.May 7 2019, 12:25 AM